#include<GL/gl.h>
#include<GL/glu.h>
#include<GL/glx.h>
#include<GL/glut.h>

/* THIS IS THE OPENGL RENDER FUNCTION */
void display(void) {	

	/* RESET ALL PIXELS TO THE VALUE SET IN MYINIT FUNCTION */
	glClear(GL_COLOR_BUFFER_BIT);

	/* DRAW THE RECTANGLE AS: BOTTOM LEFT X, BOTTOM LEFT Y, 
		TOP RIGHT Y, TOP RIGHT Y */
	glRectf(-25.0, -25.0, 25.0, 25.0);

	/* SWAP THE BUFFERS */
	glutSwapBuffers(); 
}

/* INITIALIZE OPENGL DEFAULT VALUES */
void myinit(void) {
	int w,h;

	/* SET VALUES OF WIDTH AND HEIGHT */
	w = 400;	
	h = 400;

	/* SET THE BACKROUND COLOR TO RED */
	glClearColor(1.0, 0.0, 0.0, 1.0);

	/* SET THE DRAWING COLOR TO YELLOW */
	glColor3f(1.0,1.0,0.0);	/* Foreground Color */

	/* DEFINE THE VIEWPORT: Lower Left, width height */
	glViewport(0,0,w,h);

	/* SET A CAMERA PERSPECTIVE */
	glOrtho(-50.0, 50.0, -50.0*(float)h/(float)w, 50.0*(float)h/(float)w, -1.0, 1.0);
}

/* THIS IS THE MAIN ROUTINE */
int main(int argc, char** argv) {

	/* THIS WILL INITIALIZE GLUT */
        glutInit(&argc, argv); 

	/* THIS WILL SET A DISPLAY MODE */
        glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB ); 

	/* THIS DEFINES THE WINDOW GEOMETRY */
        glutInitWindowSize(400, 400); 

	/* THIS CREATES THE WINDOW AND GIVES IT A NAME */
        glutCreateWindow("My Box"); 

	/* THIS IS MY PERSONAL INITIALIZER */
	myinit();

	/* THIS REGISTGERS THE DISPLAY FUNCTION*/
        glutDisplayFunc(display); 

	/* THIS ENTERS THE MAIN LOOP */
        glutMainLoop();
}
